
Redmine - Defect #32110

"already initialized constant Redmine::Scm::Adapters::SubversionAdapter::SVN_BIN" warning when

executing rake tasks

2019-09-22 08:31 - Go MAEDA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Code cleanup/refactoring Estimated time: 0.00 hour

Target version: 4.0.5   

Resolution: Fixed Affected version:  

Description

$ bin/rails db:fixtures:load

/Users/maeda/redmines/redmine-trunk/lib/redmine/scm/adapters/subversion_adapter.rb:29: warning: al

ready initialized constant Redmine::Scm::Adapters::SubversionAdapter::SVN_BIN

/Users/maeda/redmines/redmine-trunk/lib/redmine/scm/adapters/subversion_adapter.rb:29: warning: pr

evious definition of SVN_BIN was here

Related issues:

Related to Redmine - Defect #28920: Redmine::VERSION::revision should take su... Closed

Associated revisions

Revision 18589 - 2019-10-03 15:40 - Go MAEDA

Fix "already initialized constant Redmine::Scm::Adapters::SubversionAdapter::SVN_BIN" warning when executing rake tasks (#32110).

Patch by Go MAEDA.

Revision 18591 - 2019-10-04 01:30 - Go MAEDA

Merged r18589 from trunk to 4.0-stable (#32110).

History

#1 - 2019-09-22 10:49 - Go MAEDA

I found that the following change fixes the warning.

diff --git a/app/models/repository/bazaar.rb b/app/models/repository/bazaar.rb

index 8b07db34d..f7ad5b62c 100644

--- a/app/models/repository/bazaar.rb

+++ b/app/models/repository/bazaar.rb

@@ -17,7 +17,7 @@

 # along with this program; if not, write to the Free Software

 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

-require 'redmine/scm/adapters/bazaar_adapter'

+# require 'redmine/scm/adapters/bazaar_adapter'

 class Repository::Bazaar < Repository

   validates_presence_of :url, :log_encoding

diff --git a/app/models/repository/cvs.rb b/app/models/repository/cvs.rb

index e823275e4..03d57549d 100644

--- a/app/models/repository/cvs.rb

+++ b/app/models/repository/cvs.rb

@@ -17,7 +17,7 @@

 # along with this program; if not, write to the Free Software

 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

-require 'redmine/scm/adapters/cvs_adapter'

+# require 'redmine/scm/adapters/cvs_adapter'

 require 'digest/sha1'

 class Repository::Cvs < Repository

diff --git a/app/models/repository/filesystem.rb b/app/models/repository/filesystem.rb

index 5d823b9f4..51a93dfa1 100644

--- a/app/models/repository/filesystem.rb
+++ b/app/models/repository/filesystem.rb

@@ -20,7 +20,7 @@

 # along with this program; if not, write to the Free Software

 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

-require 'redmine/scm/adapters/filesystem_adapter'

+# require 'redmine/scm/adapters/filesystem_adapter'

 class Repository::Filesystem < Repository

   validates_presence_of :url

diff --git a/app/models/repository/git.rb b/app/models/repository/git.rb

index 839a26676..b367fe06e 100644

--- a/app/models/repository/git.rb

+++ b/app/models/repository/git.rb

@@ -18,7 +18,7 @@

 # along with this program; if not, write to the Free Software

 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

-require 'redmine/scm/adapters/git_adapter'

+# require 'redmine/scm/adapters/git_adapter'

 class Repository::Git < Repository

   validates_presence_of :url

diff --git a/app/models/repository/mercurial.rb b/app/models/repository/mercurial.rb

index 69f7bebdc..ac2921ccc 100644

--- a/app/models/repository/mercurial.rb

+++ b/app/models/repository/mercurial.rb

@@ -17,7 +17,7 @@

 # along with this program; if not, write to the Free Software

 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

-require 'redmine/scm/adapters/mercurial_adapter'

+# require 'redmine/scm/adapters/mercurial_adapter'

 class Repository::Mercurial < Repository

   # sort changesets by revision number

diff --git a/app/models/repository/subversion.rb b/app/models/repository/subversion.rb

index 0f01f863f..8e7962cd5 100644

--- a/app/models/repository/subversion.rb

+++ b/app/models/repository/subversion.rb

@@ -17,7 +17,7 @@

 # along with this program; if not, write to the Free Software

 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

-require 'redmine/scm/adapters/subversion_adapter'

+# require 'redmine/scm/adapters/subversion_adapter'

 class Repository::Subversion < Repository

   validates_presence_of :url

#2 - 2019-10-02 06:36 - Go MAEDA

The warning can be observed only when the current directory is a working copy of the Subversion repo. It means that you obtained the source code of

Redmine using "svn" command.

#3 - 2019-10-02 08:41 - Go MAEDA

It is caused by r17407. Reverting the change fixes the issue.

#4 - 2019-10-02 08:42 - Go MAEDA

- Related to Defect #28920: Redmine::VERSION::revision should take subversion_command setting into account added

#5 - 2019-10-02 09:00 - Go MAEDA

Here is a workaround.

diff --git a/lib/redmine/version.rb b/lib/redmine/version.rb

index 8272e29e4..2fe75c55e 100644

--- a/lib/redmine/version.rb

+++ b/lib/redmine/version.rb

@@ -1,6 +1,7 @@

 # frozen_string_literal: true

 require 'rexml/document'

2025-08-23 2/3

https://www.redmine.org/projects/redmine/repository/svn/revisions/17407


+require 'redmine/scm/adapters/subversion_adapter'

 module Redmine

   # @private

 Calling Redmine::Scm::Adapters::SubversionAdapter.client_command before requiring redmine/scm/adapters/subversion_adapter in the

development mode gets the warning.

$ bin/rails c

Loading development environment (Rails 5.2.3)

[1] pry(main)> Redmine::Scm::Adapters::SubversionAdapter.client_command

=> "/usr/local/bin/svn" 

[2] pry(main)> require 'redmine/scm/adapters/subversion_adapter'

/Users/maeda/redmines/redmine-trunk/lib/redmine/scm/adapters/subversion_adapter.rb:29: warning: already initia

lized constant Redmine::Scm::Adapters::SubversionAdapter::SVN_BIN

/Users/maeda/redmines/redmine-trunk/lib/redmine/scm/adapters/subversion_adapter.rb:29: warning: previous defin

ition of SVN_BIN was here

=> true

[3] pry(main)>

#6 - 2019-10-02 09:52 - Go MAEDA

- Subject changed from "already initialized constant" warning when executing rake tasks to "already initialized constant

Redmine::Scm::Adapters::SubversionAdapter::SVN_BIN" warning when executing rake tasks

- Category set to Code cleanup/refactoring

#7 - 2019-10-02 11:18 - Go MAEDA

- Target version set to Candidate for next minor release

#8 - 2019-10-03 07:57 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.0.5

Setting the target version to 4.0.5.

The patch to commit: #32110#note-5

#9 - 2019-10-03 15:41 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the fix.

#10 - 2019-10-04 01:30 - Go MAEDA

- Status changed from Resolved to Closed
